// pinoojs.js

(function (ext) {
    var device = null;
    var _rxBuf = [];

    // Sensor states:
    var ports = {
        Port1: 1,
        Port2: 2,
        Port3: 3,
        Port4: 4,
        Port5: 5,
        Port6: 6,
        Port7: 7,
        Port8: 8,
        M1: 9,
        M2: 10
    };
    var slots = {
        Slot1: 1,
        Slot2: 2
    };
    var switchStatus = {
        On: 1,
        Off: 0
    };
    var levels = {
        YUKSEK: 1,
        DUSUK: 0
    };
    var axis_about={
        X: 0,
        Y: 1
    };
    var ways_line={
        solTarafi: 0,
        sagTarafi: 1
    };
    var pinoo_pins = {
        "Pinoo 1": 2,
        "Pinoo 2": 3,
        "Pinoo 3": 4,
        "Pinoo 4": 7,
        "Pinoo 5": 8,
        "Pinoo 10": 4,
        "Pinoo 9": 2,
        "Pinoo 8": 1,
        "Pinoo 7": 0,
        "Pinoo 6": 12
    };
    var axis = {
        'X-Axis': 1,
        'Y-Axis': 2,
        'Z-Axis': 3
    }
    var tones = {
        "B0": 31, "C1": 33, "D1": 37, "E1": 41, "F1": 44, "G1": 49, "A1": 55, "B1": 62,
        "C2": 65, "D2": 73, "E2": 82, "F2": 87, "G2": 98, "A2": 110, "B2": 123,
        "C3": 131, "D3": 147, "E3": 165, "F3": 175, "G3": 196, "A3": 220, "B3": 247,
        "C4": 262, "D4": 294, "E4": 330, "F4": 349, "G4": 392, "A4": 440, "B4": 494,
        "C5": 523, "D5": 587, "E5": 659, "F5": 698, "G5": 784, "A5": 880, "B5": 988,
        "C6": 1047, "D6": 1175, "E6": 1319, "F6": 1397, "G6": 1568, "A6": 1760, "B6": 1976,
        "C7": 2093, "D7": 2349, "E7": 2637, "F7": 2794, "G7": 3136, "A7": 3520, "B7": 3951,
        "C8": 4186, "D8": 4699
    };
    var beats = { "Sustur": 0, "Ceyrek Vuruş": 250, "Yarim Vuruş": 500, "Tam Vuruş": 1000 };
    var ways = { "Ileri": 1, "Geri": 0, "Sag":2, "Sol":3};
    
    var values = {};
    var indexs = [];

    var startTimer = 0;
    var versionIndex = 0xFA;
    ext.resetAll = function () {
        device.send([0xff, 0x55, 2, 0, 4]);
    };

    ext.runArduino = function () {
        responseValue();
    };
    ext.runDigital_TR = function (pin, level) {
        runPackage(30, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin), typeof level == "string" ? levels[level] : new Number(level));
    };
    ext.runDigital_TR_2 = function (pin, level) {
        runPackage(30, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin), typeof level == "string" ? levels[level] : new Number(level));
    };
    ext.runDigital_TR_3 = function (pin, level) {
        runPackage(30, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin), typeof level == "string" ? levels[level] : new Number(level));
    };
    ext.runDigital_TR_4 = function (pin, level) {
        runPackage(30, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin), typeof level == "string" ? levels[level] : new Number(level));
    };
    ext.runDigital_TR_5 = function (pin, level) {
        runPackage(30, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin), typeof level == "string" ? levels[level] : new Number(level));
    };
    ext.runPwm = function(pin,pwm) {
        if ( ((new Number(pwm))>=0) && ((new Number(pwm))<=225) ) {
            runPackage(32,typeof pin == "string" ? pinoo_pins[pin] : new Number(pin),pwm);
        }
    };
    ext.runPwm_2 = function(pin,pwm) {
        if ( ((new Number(pwm))>=0) && ((new Number(pwm))<=225) ) {
            runPackage(32,typeof pin == "string" ? pinoo_pins[pin] : new Number(pin),pwm);
        }
    };
    ext.runPinoo_Stop_TR = function (pin, level) {
        runPackage(30, 5, 0);
        runPackage(30, 6, 0);
        runPackage(30, 10, 0);
        runPackage(30, 11, 0);
    };
    ext.runPwm_TR = function (way, pwm) {
        if ( ((new Number(pwm))>=0) && ((new Number(pwm))<=225) ) {
            if( (typeof way == "string" ? ways[way] : new Number(way)) == 0) {
            runPackage(32, 10, pwm);
            runPackage(32, 11, 0);
            runPackage(32, 5, 0);
            runPackage(32, 6, pwm);
            }
            else if ( (typeof way == "string" ? ways[way] : new Number(way)) == 1){
                
                runPackage(32, 10, 0);
                runPackage(32, 11, pwm);
                runPackage(32, 5, pwm);
                runPackage(32, 6, 0);
            }
            else if ( (typeof way == "string" ? ways[way] : new Number(way)) == 2){
                runPackage(32, 10, pwm);
                runPackage(32, 11, 0);
                runPackage(32, 5, pwm);
                runPackage(32, 6, 0);
            }
            else if ( (typeof way == "string" ? ways[way] : new Number(way)) == 3){
                runPackage(32, 10, 0);
                runPackage(32, 11, pwm);
                runPackage(32, 5, 0);
                runPackage(32, 6, pwm);
            }
        }
    };
    ext.runPwm_TR_Wheel = function (wheel, way, pwm) {
        if ( ((new Number(pwm))>=0) && ((new Number(pwm))<=225) ) {
            if( (typeof wheel == "string" ? ways[wheel] : new Number(wheel)) == 2){
                if( (typeof way == "string" ? ways[way] : new Number(way)) == 0) {
                    runPackage(32, 10, pwm);
                    runPackage(32, 11, 0);
                }
                else{
                    
                    runPackage(32, 10, 0);
                    runPackage(32, 11, pwm);
                }
            }
            else{
                if( (typeof way == "string" ? ways[way] : new Number(way)) == 1){
                    runPackage(32, 5, pwm);
                    runPackage(32, 6, 0);
                }
                else{
                    
                    runPackage(32, 5, 0);
                    runPackage(32, 6, pwm);
                }
            }
        }
    };
    ext.runTone_TR = function (pin, tone, beat) {
        if(short2array(typeof beat == "number" ? beat : beats[beat]) != 0){
            runPackage(34, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin), short2array(typeof tone == "number" ? tone : tones[tone]), short2array(typeof beat == "number" ? beat : beats[beat]));   
        }
        else{
            runPackage(30, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin), 0);
        }
    };
    ext.runServoArduino_TR = function (pin, angle) {
        runPackage(33, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin), angle);
    };
    ext.resetTimer = function () {
        startTimer = new Date().getTime();
        responseValue();
    };
    ext.getDigital_TR = function (nextID, pin) {
        var deviceId = 30;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getDigital_TR_1 = function (nextID, pin) {
        var deviceId = 30;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getDigital_TR_2 = function (nextID, pin) {
        var deviceId = 30;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getDigital_TR_3 = function (nextID, pin) {
        var deviceId = 30;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getDigital_TR_4 = function (nextID, pin) {
        var deviceId = 30;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getDigital_TR_5 = function (nextID, pin) {
        var deviceId = 30;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getDigital_TR_6 = function (nextID, pin) {
        var deviceId = 30;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getDigital_TR_7 = function (nextID, pin) {
        var deviceId = 30;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getDigital_TR_8 = function (nextID, pin) {
        var deviceId = 30;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getAnalog_TR = function (nextID, pin) {
        var deviceId = 31;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getAnalog_2_TR = function (nextID,axis_about_come, pin ) {
        var deviceId = 31;
        var a = (typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
        var b = a + (typeof axis_about_come == "string" ? axis_about[axis_about_come] : new Number(axis_about_come));
        getPackage(nextID, deviceId, b);
    };
    ext.getLinefollower_TR = function (nextID,pin,axis_about_come ) {
        var deviceId = 31;
        var a = (typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
        var b = a + (typeof axis_about_come == "string" ? ways_line[axis_about_come] : new Number(axis_about_come));
        getPackage(nextID, deviceId, b);
    };
    ext.getAnalog_TR_2 = function (nextID, pin) {
        var deviceId = 31;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getAnalog_TR_3 = function (nextID, pin) {
        var deviceId = 31;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getAnalog_TR_4 = function (nextID, pin) {
        var deviceId = 31;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getAnalog_TR_5 = function (nextID, pin) {
        var deviceId = 31;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getAnalog_TR_6 = function (nextID, pin) {
        var deviceId = 31;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getAnalog_TR_7 = function (nextID, pin) {
        var deviceId = 31;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getAnalog_TR_8 = function (nextID, pin) {
        var deviceId = 31;
        getPackage(nextID, deviceId, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    };
    ext.getPulse = function (nextID, pin, timeout) {
        var deviceId = 37;
        getPackage(nextID, deviceId, pin, short2array(timeout));
    };
    ext.getUltrasonicArduino_TR = function (nextID, pin) {
        var deviceId = 36;
        getPackage(nextID, deviceId, (typeof pin == "string" ? pinoo_pins[pin] : new Number(pin)) + 1, typeof pin == "string" ? pinoo_pins[pin] : new Number(pin));
    }
    ext.getTimer = function (nextID) {
        if (startTimer == 0) {
            startTimer = new Date().getTime();
        }
        responseValue(nextID, new Date().getTime() - startTimer);
    }

    function sendPackage(argList, type) {
        var bytes = [0xff, 0x55, 0, 0, type];
        for (var i = 0; i < argList.length; ++i) {
            var val = argList[i];
            if (val.constructor == "[class Array]") {
                bytes = bytes.concat(val);
            } else {
                bytes.push(val);
            }
        }
        bytes[2] = bytes.length - 3;
        device.send(bytes);
    }
    function runPackage() {
        sendPackage(arguments, 2);
    }
    function getPackage() {
        var nextID = arguments[0];
        Array.prototype.shift.call(arguments);
        sendPackage(arguments, 1);
    }
    var inputArray = [];
    var _isParseStart = false;
    var _isParseStartIndex = 0;
    function processData(bytes) {
        var len = bytes.length;
        if (_rxBuf.length > 30) {
            _rxBuf = [];
        }
        for (var index = 0; index < bytes.length; index++) {
            var c = bytes[index];
            _rxBuf.push(c);
            if (_rxBuf.length >= 2) {
                if (_rxBuf[_rxBuf.length - 1] == 0x55 && _rxBuf[_rxBuf.length - 2] == 0xff) {
                    _isParseStart = true;
                    _isParseStartIndex = _rxBuf.length - 2;
                }
                if (_rxBuf[_rxBuf.length - 1] == 0xa && _rxBuf[_rxBuf.length - 2] == 0xd && _isParseStart) {
                    _isParseStart = false;

                    var position = _isParseStartIndex + 2;
                    var extId = _rxBuf[position];
                    position++;
                    var type = _rxBuf[position];
                    position++;
                    //1 byte 2 float 3 short 4 len+string 5 double
                    var value;
                    switch (type) {
                        case 1: {
                            value = _rxBuf[position];
                            position++;
                        }
                            break;
                        case 2: {
                            value = readFloat(_rxBuf, position);
                            position += 4;
                            if (value < -255 || value > 1023) {
                                value = 0;
                            }
                        }
                            break;
                        case 3: {
                            value = readInt(_rxBuf, position, 2);
                            position += 2;
                        }
                            break;
                        case 4: {
                            var l = _rxBuf[position];
                            position++;
                            value = readString(_rxBuf, position, l);
                        }
                            break;
                        case 5: {
                            value = readDouble(_rxBuf, position);
                            position += 4;
                        }
                            break;
                        case 6:
                            value = readInt(_rxBuf, position, 4);
                            position += 4;
                            break;
                    }
                    if (type <= 6) {
                        responseValue(extId, value);
                    } else {
                        responseValue();
                    }
                    _rxBuf = [];
                }
            }
        }
    }
    function readFloat(arr, position) {
        var f = [arr[position], arr[position + 1], arr[position + 2], arr[position + 3]];
        return parseFloat(f);
    }
    function readInt(arr, position, count) {
        var result = 0;
        for (var i = 0; i < count; ++i) {
            result |= arr[position + i] << (i << 3);
        }
        return result;
    }
    function readDouble(arr, position) {
        return readFloat(arr, position);
    }
    function readString(arr, position, len) {
        var value = "";
        for (var ii = 0; ii < len; ii++) {
            value += String.fromCharCode(_rxBuf[ii + position]);
        }
        return value;
    }
    function appendBuffer(buffer1, buffer2) {
        return buffer1.concat(buffer2);
    }

    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function (dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }

    var watchdog = null;
    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('Pinoo', processData);
    };

    ext._deviceRemoved = function (dev) {
        if (device != dev) return;
        device = null;
    };

    ext._shutdown = function () {
        if (device) device.close();
        device = null;
    };

    ext._getStatus = function () {
        if (!device) return { status: 1, msg: 'Pinoo disconnected' };
        if (watchdog) return { status: 1, msg: 'Probing for Pinoo' };
        return { status: 2, msg: 'Pinoo connected' };
    }

    var descriptor = {};
    ScratchExtensions.register('Pinoo', descriptor, ext, { type: 'serial' });
})({});
